Index: pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/call.hpp
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/call.hpp	(revision 4670)
+++ pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/call.hpp	(revision 4672)
@@ -27,4 +27,8 @@
 #include <pjsua2/media.hpp>
 
+/** PJSUA2 API is inside pj namespace */
+namespace pj
+{
+
 /**
  * @defgroup PJSUA2_CALL Call
@@ -33,12 +37,9 @@
 
 /**
- * @defgroup PJSUA2_Call_Data_Structure Data Structure
- * @ingroup PJSUA2_Ref
+ * @defgroup PJSUA2_Call_Data_Structure Call Related Types
+ * @ingroup PJSUA2_DS
  * @{
  */
 
-/** PJSUA2 API is inside pj namespace */
-namespace pj
-{
 using std::string;
 using std::vector;
@@ -308,5 +309,5 @@
 {
     /**
-     * Bitmask of #pjsua_call_flag constants.
+     * Bitmask of pjsua_call_flag constants.
      *
      * Default: PJSUA_CALL_INCLUDE_DISABLED_MEDIA
@@ -316,5 +317,5 @@
     /**
      * This flag controls what methods to request keyframe are allowed on
-     * the call. Value is bitmask of #pjsua_vid_req_keyframe_method.
+     * the call. Value is bitmask of pjsua_vid_req_keyframe_method.
      *
      * Default: PJSUA_VID_REQ_KEYFRAME_SIP_INFO |
@@ -622,5 +623,5 @@
 
 /**
- * This structure contains parameters for onCallState() callback.
+ * This structure contains parameters for Call::onCallState() callback.
  */
 struct OnCallStateParam
@@ -633,5 +634,5 @@
 
 /**
- * This structure contains parameters for onCallTsxState() callback.
+ * This structure contains parameters for Call::onCallTsxState() callback.
  */
 struct OnCallTsxStateParam
@@ -644,5 +645,5 @@
 
 /**
- * This structure contains parameters for onCallMediaState() callback.
+ * This structure contains parameters for Call::onCallMediaState() callback.
  */
 struct OnCallMediaStateParam
@@ -651,5 +652,5 @@
 
 /**
- * This structure contains parameters for onCallSdpCreated() callback.
+ * This structure contains parameters for Call::onCallSdpCreated() callback.
  */
 struct OnCallSdpCreatedParam
@@ -667,5 +668,6 @@
 
 /**
- * This structure contains parameters for onStreamCreated() callback.
+ * This structure contains parameters for Call::onStreamCreated()
+ * callback.
  */
 struct OnStreamCreatedParam
@@ -690,5 +692,6 @@
 
 /**
- * This structure contains parameters for onStreamDestroyed() callback.
+ * This structure contains parameters for Call::onStreamDestroyed()
+ * callback.
  */
 struct OnStreamDestroyedParam
@@ -706,5 +709,6 @@
 
 /**
- * This structure contains parameters for onDtmfDigit() callback.
+ * This structure contains parameters for Call::onDtmfDigit()
+ * callback.
  */
 struct OnDtmfDigitParam
@@ -717,5 +721,6 @@
 
 /**
- * This structure contains parameters for onCallTransferRequest() callback.
+ * This structure contains parameters for Call::onCallTransferRequest()
+ * callback.
  */
 struct OnCallTransferRequestParam
@@ -740,5 +745,6 @@
 
 /**
- * This structure contains parameters for onCallTransferStatus() callback.
+ * This structure contains parameters for Call::onCallTransferStatus()
+ * callback.
  */
 struct OnCallTransferStatusParam
@@ -769,5 +775,6 @@
 
 /**
- * This structure contains parameters for onCallReplaceRequest() callback.
+ * This structure contains parameters for Call::onCallReplaceRequest()
+ * callback.
  */
 struct OnCallReplaceRequestParam
@@ -797,5 +804,5 @@
 
 /**
- * This structure contains parameters for onCallReplaced() callback.
+ * This structure contains parameters for Call::onCallReplaced() callback.
  */
 struct OnCallReplacedParam
@@ -808,5 +815,5 @@
 
 /**
- * This structure contains parameters for onCallRxOffer() callback.
+ * This structure contains parameters for Call::onCallRxOffer() callback.
  */
 struct OnCallRxOfferParam
@@ -831,4 +838,7 @@
 };
 
+/**
+ * This structure contains parameters for Call::onCallRedirected() callback.
+ */
 struct OnCallRedirectedParam
 {
@@ -843,5 +853,5 @@
      * received for the INVITE sent to subsequent targets, or empty
      * (e.type == PJSIP_EVENT_UNKNOWN)
-     * if this callback is called from within #Call::processRedirect()
+     * if this callback is called from within Call::processRedirect()
      * context.
      */
@@ -850,5 +860,5 @@
 
 /**
- * This structure contains parameters for onCallMediaEvent() callback.
+ * This structure contains parameters for Call::onCallMediaEvent() callback.
  */
 struct OnCallMediaEventParam
@@ -866,5 +876,6 @@
 
 /**
- * This structure contains parameters for onCallMediaTransportState() callback.
+ * This structure contains parameters for Call::onCallMediaTransportState()
+ * callback.
  */
 struct OnCallMediaTransportStateParam
@@ -892,5 +903,6 @@
 
 /**
- * This structure contains parameters for onCreateMediaTransport() callback.
+ * This structure contains parameters for Call::onCreateMediaTransport()
+ * callback.
  */
 struct OnCreateMediaTransportParam
@@ -1093,5 +1105,5 @@
      * Get media for the specified media index.
      *
-     * @psaram med_idx      Media index.
+     * @param med_idx       Media index.
      *
      * @return              The media or NULL if invalid or inactive.
@@ -1118,5 +1130,5 @@
      * @return              PJSIP_DIALOG_CAP_SUPPORTED if the specified
      *                      capability is explicitly supported, see
-     *                      @pjsip_dialog_cap_status for more info.
+     *                      pjsip_dialog_cap_status for more info.
      */
     pjsip_dialog_cap_status remoteHasCap(int htype,
@@ -1126,5 +1138,5 @@
     /**
      * Attach application specific data to the call. Application can then
-     * inspect this data by calling #Call::getUserData().
+     * inspect this data by calling getUserData().
      *
      * @param user_data     Arbitrary data to be attached to the call.
@@ -1134,5 +1146,5 @@
     /**
      * Get user data attached to the call, which has been previously set with
-     * #Call::setUserData().
+     * setUserData().
      *
      * @return              The user data.
@@ -1143,5 +1155,5 @@
      * Get the NAT type of remote's endpoint. This is a proprietary feature
      * of PJSUA-LIB which sends its NAT type in the SDP when \a natTypeInSdp
-     * is set in #UaConfig.
+     * is set in UaConfig.
      *
      * This function can only be called after SDP has been received from remote,
@@ -1180,9 +1192,8 @@
      *  - if no call setting is supplied when SDP has to be sent, i.e: answer
      *    with status code 183 or 2xx, the default call setting will be used,
-     *    check #CallSetting for its default values.
+     *    check CallSetting for its default values.
      *
      * @param prm.opt       Optional call setting.
-     * @param prm.statusCode    
-     *                      Status code, (100-699).
+     * @param prm.statusCode   Status code, (100-699).
      * @param prm.reason    Optional reason phrase. If empty, default text
      *                      will be used.
@@ -1197,7 +1208,7 @@
      * Hangup call by using method that is appropriate according to the
      * call state. This function is different than answering the call with
-     * 3xx-6xx response (with #Call::answer()), in that this function
+     * 3xx-6xx response (with answer()), in that this function
      * will hangup the call regardless of the state and role of the call,
-     * while #Call::answer() only works with incoming calls on EARLY
+     * while answer() only works with incoming calls on EARLY
      * state.
      *
@@ -1395,7 +1406,7 @@
      *
      * @param op            The video stream operation to be performed,
-     *                      possible values are #pjsua_call_vid_strm_op.
+     *                      possible values are pjsua_call_vid_strm_op.
      * @param param         The parameters for the video stream operation
-     *                      (see #CallVidSetStreamParam).
+     *                      (see CallVidSetStreamParam).
      */
     void vidSetStream(pjsua_call_vid_strm_op op,
@@ -1447,5 +1458,5 @@
      * Notify application when call state has changed.
      * Application may then query the call info to get the
-     * detail call states by calling Call::getInfo() function.
+     * detail call states by calling getInfo() function.
      *
      * @param prm	Callback parameter.
@@ -1639,5 +1650,5 @@
      *			  no decision can be made immediately (for example
      *			  to request confirmation from user). Application
-     *			  then MUST call #Call::processRedirect()
+     *			  then MUST call processRedirect()
      *			  to either accept or reject the redirection upon
      *			  getting user decision.
@@ -1693,10 +1704,10 @@
 };
 
+/**
+ * @}  // PJSUA2_CALL
+ */
+
 } // namespace pj
 
-/**
- * @}  // PJSUA2_CALL
- */
-
 #endif	/* __PJSUA2_CALL_HPP__ */
 